<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';
import { SideNavigationVariant } from '../common/index.vue';
import { BySolutionIntro } from '../solutions/by-solution/index.vue';
import { CtfButton } from '../../models/content-types.dto';

import Tabs from '../customers/tabs.vue';
import { IsMobileMixin } from '~/mixins';

interface Overview {
  id: string;
  title: string;
  text: {
    highlight?: string;
    description: string;
    textVariant?: string;
  };
}

interface EsgBlock {
  id: string;
  header: string;
  description: string;
  image: {
    src: string;
    alt?: string;
  };
  primaryButton?: CtfButton;
  secondaryButton?: CtfButton;
}

interface EsgSection {
  name: string;
  purpleBackground: boolean;
  blocks: EsgBlock[];
}
export default Vue.extend({
  components: {
    SideNavigationVariant,
    BySolutionIntro,
    Tabs,
  },
  mixins: [IsMobileMixin],
  props: {
    overview: {
      type: Object as PropType<Overview>,
      required: false,
      default: null,
    },
    sections: {
      type: Array as PropType<EsgSection[]>,
      required: true,
    },
  },
  data() {
    const navLinks = [
      this.overview && {
        title: this.overview.header,
        href: `#${this.overview.id}`,
      },
      ...this.sections.map((section) => ({
        title: section.name,
        href: `#${section.id}`,
      })),
    ];
    const tabs = this.sections.map((section) => section.name);
    return {
      navLinks,
      tabs,
      selectedTab: 0,
    };
  },
  methods: {
    changeTab(newTab: number) {
      this.selectedTab = newTab;
    },
  },
});
</script>

<template>
  <SideNavigationVariant :links="navLinks">
    <SlpContainer v-if="overview" :id="overview.id">
      <BySolutionIntro :data="overview" />
    </SlpContainer>
    <Tabs
      v-if="isMobile"
      :tabs="tabs"
      :selected-tab="selectedTab"
      class="tabs"
      @change="changeTab"
    />
    <SlpContainer
      v-for="(section, sectionIndex) in sections"
      v-show="!isMobile || (isMobile && sectionIndex === selectedTab)"
      :id="section.name.toLowerCase()"
      :key="section.name"
      class="section"
    >
      <div class="section__main-content">
        <SlpTypography
          v-if="section.header"
          variant="heading3-bold"
          tag="h2"
          class="slp-mb-48"
        >
          {{ section.header }}
        </SlpTypography>
        <SlpTypography
          v-if="section.description"
          variant="body1"
          tag="p"
          class="slp-mt-48"
        >
          {{ section.description }}
        </SlpTypography>
      </div>
      <div class="section__cards">
        <div
          v-for="block in section.blocks"
          :key="block.header"
          class="esg-block"
        >
          <div class="text">
            <SlpTypography variant="heading5-bold" tag="h3">
              {{ block.header }}
            </SlpTypography>
            <SlpTypography variant="body1" tag="div">
              <div v-html="$md.render(block.description)"></div>
            </SlpTypography>
            <div>
              <SlpButton
                v-if="block.primaryButton"
                variant="tertiary"
                :href="block.primaryButton.externalUrl"
                :data-ga-name="block.primaryButton.dataGaName"
                :data-ga-location="block.primaryButton.dataGaLocation"
                >{{ block.primaryButton.text }}
                <SlpIcon name="chevron-right" variant="product"
              /></SlpButton>
              <SlpButton
                v-if="block.secondaryButton"
                variant="tertiary"
                :href="block.secondaryButton.externalUrl"
                :data-ga-name="block.secondaryButton.dataGaName"
                :data-ga-location="block.secondaryButton.dataGaLocation"
                >{{ block.secondaryButton.text }}
                <SlpIcon name="chevron-right" variant="product"
              /></SlpButton>
            </div>
          </div>
        </div>
      </div>
    </SlpContainer>
  </SideNavigationVariant>
</template>

<style lang="scss" scoped>
.tabs {
  @media (min-width: $breakpoint-lg) {
    display: none;
  }
}
.section {
  padding: 32px;
  max-width: 100%;
  background-color: #fff;
  margin-bottom: 64px;
  border-radius: 8px;
  max-width: 100%;

  @media (max-width: $breakpoint-md) {
    overflow-x: scroll;
  }
  &__cards {
    display: flex;
    flex-direction: column;
    gap: 48px;

    @media (max-width: $breakpoint-md) {
      flex-direction: row;
      flex-wrap: nowrap;

      gap: 16px;
    }
  }
  &.purple-background {
    position: relative;
    &::after {
      background: #f6f3fe;
      content: '';
      height: 100%;
      left: -50vw;
      position: absolute;
      top: 0;
      width: 200vw;
      z-index: -1;
    }
  }
  &__main-content {
    flex-break: after;
  }
}
.esg-block {
  display: flex;
  flex-direction: row;
  gap: 64px;
  // flex-direction: column;
  // gap: 0;
  @media (min-width: $breakpoint-lg) {
    flex-direction: row;
    gap: 64px;
  }
  @media (max-width: $breakpoint-lg) {
    min-width: 100%;
  }
  .text {
    display: flex;
    flex-direction: column;
    gap: 16px;
    @media (max-width: $breakpoint-md) {
      padding: 0 32px 0 0;
    }
  }
  .image img {
    border-radius: 0px 0px 82px 4px;
    object-fit: cover;
    max-width: 100%;
    width: 100%;
    @media (min-width: $breakpoint-lg) {
      border-radius: 4px 4px 82px 4px;
      width: 375px;
      height: 314px;
      max-width: unset;
    }
  }
  :deep {
    .slp-btn-tertiary {
      text-align: left;
    }
    a:not(.slp-btn) {
      color: $color-primary-200;
      text-decoration: underline;
      text-decoration-color: currentColor;
      transition: all 0.3s ease;
      &:hover,
      &:focus {
        text-decoration-color: transparent;
      }
    }
  }
}
</style>
